<?php
// location of nslinkadmin
$nslinkadmin = "/usr/sbin/nslinkadmin-wpv";
$cachedtime = 3; // the time in seconds to show a cached devices page. this is to prevent 100 requests to the network from the app
                 // this will only allow one network request to go out within this time period.
$interfaces = array(1 => eth0, 2 => eth1);
$debugport = 4607;

$dontdosession = 0;
if ($_REQUEST['debugdevice']) { $dontdosession = 1; }

if (! $dontdosession) {
  session_start();
}
// get any use defined filters 
if ($_REQUEST['setfilters']) { 
  $_SESSION['namefilter'] = $_REQUEST['namefilter'];
  $_SESSION['ipfilter'] = $_REQUEST['ipfilter'];
  $_SESSION['macfilter'] = $_REQUEST['macfilter'];
  $_SESSION['statusfilter'] = $_REQUEST['statusfilter'];
  $_SESSION['ownedfilter'] = $_REQUEST['ownedfilter'];
}
elseif (! $_SESSION['namefilter']) { $_SESSION['namefilter'] = ""; }

// get any user defined network interface that should be used to query for devices
if ($_REQUEST['interface']) { $_SESSION['interface'] = $_REQUEST['interface']; }
elseif (! $_SESSION['interface']) { $_SESSION['interface'] = "eth0"; }

// get any user selected sort column
if ($_REQUEST['sort']) {
  if ($_SESSION['sort'] == $_REQUEST['sort']) {
    // if they have selected the same sort twice, switch ascending and descending
    if ($_SESSION['ASCDESC'] == "ASC") { $_SESSION['ASCDESC'] = "DESC"; }
    else { $_SESSION['ASCDESC'] = "ASC"; }
  }
  else {
    $_SESSION['ASCDESC'] = "ASC";
  }
  $_SESSION['sort'] = $_REQUEST['sort'];
}
else {
  if (! $_SESSION['sort']) { $_SESSION['sort'] = "name"; }
  if (! $_SESSION['ASCDESC']) {   $_SESSION['ASCDESC'] = "ASC"; }
}

if ($_REQUEST['autorefresh']) { $_SESSION['autorefresh'] = $_REQUEST['autorefresh']; }

$namefilter = $_SESSION['namefilter'];
$ipfilter = $_SESSION['ipfilter'];
$macfilter = $_SESSION['macfilter'];
$statusfilter = $_SESSION['statusfilter'];
$ownedfilter = $_SESSION['ownedfilter'];
$interface = $_SESSION['interface'];
$sort = $_SESSION['sort'];
$ascdesc = $_SESSION['ASCDESC'];
//$self = basename($PHP_SELF);
$self = $_SERVER['SCRIPT_NAME'];
$autorefresh = $_SESSION['autorefresh'];

// here we have user choices that call actions or different pages. order here is important
// if they have selected to have a devices firmware flashed
if ($_REQUEST['firmwareupload']) { guiflashdevice($_REQUEST['mac'], $interface); exit;}

// if they have selected to have a device reset
if ($_REQUEST['reset']) { resetdevice($_REQUEST['reset'], $interface); }

// to set ip info
if ($_REQUEST['setipinfo']) { setipinfo($_REQUEST['mac'], $interface, $_REQUEST['ip'], $_REQUEST['mask'], $_REQUEST['gateway']);}

// if they have selected a device show only that device
if ($_REQUEST['mac']) { onedevice($_REQUEST['mac'], $interface); exit; }

// if they have selected a to debug a device
if ($_REQUEST['debugdevice']) { debugsocket($_REQUEST['ip']); exit; }

// if they have selected multiple devices to reset
if ($_REQUEST['massreset']) {
  foreach ($_REQUEST['selection'] as $device) {
    resetdevice($device, $interface);
  }
}

// if they have selected multiple devices to flash
// this action has been moved into the display area so the user gets some feedback

// if they have selected a to generate reports
if ($_REQUEST['reportdminstaller']) { reportdminstaller($_REQUEST['selection']); exit; }
// if they have selected a to generate reports
if ($_REQUEST['reportnslinkconf']) { reportnslinkconf($_REQUEST['selection']); exit; }

$cachefile = "cache$interface";
$alldevices = scandevices();

if (is_numeric($autorefresh)) { $metarefresh = "<META HTTP-EQUIV=\"REFRESH\" content=\"$autorefresh\">"; }
else { $metarefresh = ""; }

?>
<html>
<head>
  <title>Web PortVision</title>
  <?=$metarefresh?>
  <SCRIPT language=JavaScript>
  function LaunchDevice(macaddr)
  {
    DeviceProperties = eval("window.open(\"<?=$self?>?mac="+macaddr+"\",\"DeviceProperties"+macaddr+"\",\"toolbar=0,menubar=0,scrollbars=1,resizable=1,width=700,height=400\")")
  }
  function DebugDevice(ipaddr, sortip)
  {
    DebugPortMonitor = eval("window.open(\"<?=$self?>?debugdevice=1&ip="+ipaddr+"\",\"DeviceDebugPort"+sortip+"\",\"toolbar=0,menubar=1,scrollbars=1,resizable=1,width=700,height=400\")")
  }
  function CheckStuff(field, value)
  {
    for(i = 0; i < field.elements.length; i++)
      field.elements[i].checked = value;
  }
  </SCRIPT>
</head>
<body>
<?
if ($_REQUEST['massflash']) {
  echo "<font color=red><big>Flashing devices now, in the background... </big></font><br>\n";
  flush();
  foreach ($_REQUEST['selection'] as $device) {
    flashdevice($device, $interface);
  }
}
?>
<table width="100%" border="0" cellpadding="1" cellspacing="1">
  <tbody>
    <tr>
      <td width=33%>
        <div align=left>
        <form method="GET" action="<?php echo $self; ?>"> 
           <SELECT NAME="interface">
           <?php
           foreach ($interfaces as $interfaceoption) {
             if ($interface == $interfaceoption) { 
               echo "<OPTION SELECTED>$interfaceoption";
             }
             else {
               echo "<OPTION>$interfaceoption";
             }
           }
           ?>
           </SELECT>
           <input type="submit" value="Set Interface">
        </form>
        </div>
      </td>
      <td width=34%>
        <div align=center>
        <form method="GET" action="<?php echo $self; ?>"> 
          <input type="submit" value="Refresh Page">
        </form>
        </div>
      </td>
      <td width=33%>
        <div align=right>
        <form method="GET" action="<?=$self?>"> 
           <SELECT NAME="autorefresh">
           <OPTION<?php if ($autorefresh == "Off") { echo " SELECTED"; } ?>>Off
           <OPTION<?php if ($autorefresh == 5) { echo " SELECTED"; } ?>>5
           <OPTION<?php if ($autorefresh == 10) { echo " SELECTED"; } ?>>10
           <OPTION<?php if ($autorefresh == 30) { echo " SELECTED"; } ?>>30
           <OPTION<?php if ($autorefresh == 60) { echo " SELECTED"; } ?>>60
           <OPTION<?php if ($autorefresh == 600) { echo " SELECTED"; } ?>>600
           </SELECT> Seconds
           <input type="submit" value="Set AutoRefresh">
        </form>
        </div>
      </td>
    </tr>
  </tbody>
</table>
<br>
<?php
$debug = 0;

// now filter the devices to show only those the users wants to see, but retain all of them for storage in the cache file
$fc = 0;
$ac = 0;
foreach ($alldevices as $device) {
  $passfilters = 1;
  if ($namefilter) { if (substr_count($device[name], $namefilter) == 0) { $passfilters = 0; }}
  if ($ipfilter) { if (substr_count($device[ip], $ipfilter) == 0) { $passfilters = 0; }}
  if ($macfilter) { if (substr_count($device[mac], $macfilter) == 0) { $passfilters = 0; }}
  if ($statusfilter) { if (substr_count($device[status], $statusfilter) == 0) { $passfilters = 0; }}
  if ($ownedfilter) { if (substr_count($device[owned], $ownedfilter) == 0) { $passfilters = 0; }}

  if ($passfilters) {
    $devices[$fc][mac] = $device[mac];
    $devices[$fc][name] = $device[name];
    $devices[$fc][status] = $device[status];
    $devices[$fc][owned] = $device[owned];
    $devices[$fc][ip] = $device[ip];
    $devices[$fc][sortip] = $device[sortip];
    $devices[$fc][sortmac] = $device[sortmac];
    $devices[$fc][mask] = $device[mask];
    $devices[$fc][gateway] = $device[gateway];
    $fc++;
  }
  $ac++;
}

if ($devices[0][mac]) {
  foreach ($devices as $key => $value) {
    $sortarray[$key]  = $value[$sort];
    $macarray[$key] = $value[mac]; // always store the mac addresses as well since we will always do a secondary sort by mac address
    if ($debug) {
      echo "<pre>\n";
      echo "-----------------\n";
      echo "name:    $value[name]\n";
      echo "mac:     $value[mac]\n";
      echo "ip:      $value[ip]\n";
      echo "status:  $value[status]\n";
      echo "owned:   $value[owned]\n";
      echo "mask:    $value[mask]\n";
      echo "gateway: $value[gateway]\n";
      echo "</pre>\n";
    }
  }

  // sort the array before displaying
  if ($ascdesc == "ASC") { 
    $ascdescimg="ic_sort_a.gif";
    array_multisort($sortarray, SORT_ASC, $macarray, SORT_ASC, $devices);
  }
  elseif ($ascdesc == "DESC") { 
    $ascdescimg="ic_sort_d.gif";
    array_multisort($sortarray, SORT_DESC, $macarray, SORT_ASC, $devices); 
  }

  $nameimg = "";
  $macimg = "";
  $ipimg = "";
  $statusimg = "";
  $ownedimg = "";

  if ($sort == "name") { $nameimg = "<img border=0 src=\"images/$ascdescimg\">"; }
  elseif ($sort == "mac") { $macimg = "<img border=0 src=\"images/$ascdescimg\">"; }
  elseif ($sort == "sortip") { $ipimg = "<img border=0 src=\"images/$ascdescimg\">"; }
  elseif ($sort == "status") { $statusimg = "<img border=0 src=\"images/$ascdescimg\">"; }
  elseif ($sort == "owned") { $ownedimg = "<img border=0 src=\"images/$ascdescimg\">"; } 
  } // end of else if devices[0][mac] exists

  // display a small table with some stats
  echo "<table width=\"100%\" border=\"0\" cellpadding=\"1\" cellspacing=\"1\">";
  echo "<tr>\n";
  echo "<td><center>All Devices Detected: $ac</center></td>\n";
  echo "<td><center>Current Filtered Devices Listed: $fc</center></td>\n";
  echo "</tr>\n";
  echo "</table>\n";
?>
<table width="100%" border="0" cellpadding="1" cellspacing="1">
  <tbody>
    <tr>
      <form method="POST" action="<?php echo $self; ?>"> 
      <td>&nbsp;</td>
      <td><input type=text name="namefilter" value="<?php echo $namefilter; ?>" size=20> </td>
      <td><input type=text name="ipfilter" value="<?php echo $ipfilter; ?>" size=15> </td>
      <td><input type=text name="macfilter" value="<?php echo $macfilter; ?>" size=17> </td>
      <td><input type=text name="statusfilter" value="<?php echo $statusfilter; ?>" size=8> </td>
      <td><input type="submit" name="setfilters" value="Set Filters"></td>
      </form>
    </tr>
    <form method="POST" enctype="multipart/form-data" name="devicelist" action="<?php echo $self; ?>">
    <tr>
      <td bgcolor=#D3DCE3><input type="checkbox" name="checkall" onClick="CheckStuff(document.devicelist, this.checked)"></td>
      <td bgcolor=#D3DCE3><a href="<?php echo $self?>?sort=name">Name<?=$nameimg?></a></td>
      <td bgcolor=#D3DCE3><a href="<?php echo $self?>?sort=sortip">IP Address<?=$ipimg?></a></td>
      <td bgcolor=#D3DCE3><a href="<?php echo $self?>?sort=mac">Mac Address<?=$macimg?></a></td>
      <td bgcolor=#D3DCE3><a href="<?php echo $self?>?sort=status">Ready for use?<?=$statusimg?></a></td>
      <td bgcolor=#D3DCE3>Actions</td>
    </tr>
<?php
if (! $devices[0][mac]) {
  echo "</tbody></table>\n";
  echo "<font color=red>No devices detected with the applied filters</font><br>\n";
}
else {
  $c = 0;
  foreach ($devices as $device) {
    echo "<tr>\n";
    if ($c == 0) {
      $color = "#CCCCCC";
      $c++;
    }
    else {
      $color = "#DDDDDD";
      $c = 0;
    }
    echo "<td BGCOLOR=$color><input type=\"checkbox\" name=\"selection[]\" value=\"$device[mac]\"</td>";
    echo "<td BGCOLOR=$color><A HREF=\"javascript:LaunchDevice('$device[mac]','$device[sortmac]')\">$device[name]</a></td>\n";
    echo "<td BGCOLOR=$color><a href=\"http://$device[ip]\">$device[ip]</a></td>\n";
    echo "<td BGCOLOR=$color><pre>$device[mac]</pre></td>\n";
    if ($device[status] == "YES") {
      echo "<td BGCOLOR=$color><font color=green>$device[status]</font></td>\n";
    }
    elseif ($device[status] == "NO") {
      echo "<td BGCOLOR=$color><font color=red>$device[status]</font></td>\n";
    }
    echo "<td BGCOLOR=$color><a href=\"$self?reset=$device[mac]\">[Reboot]</a> <a href=\"\" onClick=\"javascript:DebugDevice('$device[ip]','$device[sortip]')\">[Debug]</a></td>\n";
    echo "</tr>\n";
  }
  ?>
    </tbody>
  <table>
  <?php
  echo "Batch: <input type=\"submit\" name=\"massreset\" value=\"Reboot\"><br>\n";  
  echo "Batch Reports: <input type=\"submit\" name=\"reportnslinkconf\" value=\"nslink.conf\"> <input type=\"submit\" name=\"reportdminstaller\" value=\"DeviceMasterInstaller.ini\"><br>\n";  
  echo "Batch Firmware:\n";
  ?>
  <input type="hidden" name="mac" value="<?=$mac?>">
  <!-- MAX_FILE_SIZE must precede the file input field -->
  <input type="hidden" name="MAX_FILE_SIZE" value="3000000" />
  <!-- Name of input element determines name in $_FILES array -->
  <input name="userfile" type="file" />
  <input type="submit" name="massflash" value="Upload Firmware" />
  <?
  echo "</form>\n";
} // end of else if devices[0][mac] exists
?>
</body>
</html>
<?php

writecachedata($alldevices);

function reportnslinkconf($selection) {
  $alldevices = scandevices();
  $c = 0;
  foreach ($alldevices as $device) {
    foreach ($selection as $key => $value) {
      if ($device[mac] == $value) {
        $devices[$c][mac] = $device[mac];
        $devices[$c][name] = $device[name];
        $devices[$c][status] = $device[status];
        $devices[$c][owned] = $device[owned];
        $devices[$c][ip] = $device[ip];
        $devices[$c][sortip] = $device[sortip];
        $devices[$c][sortmac] = $device[sortmac];
        $devices[$c][mask] = $device[mask];
        $devices[$c][gateway] = $device[gateway];
        $c++;
      }
    }
  }

  echo "<pre>\n";
  echo "# /etc/nslink.conf\n";
  echo "# For use with Linux DeviceMaster driver\n";
  echo "# Autogenerated by Web PortVision\n";
  echo "# MODIFY AS NEEDED\n";
  echo "\n";
  $c=0;
  foreach ($devices as $device) {
    list ($model, $cname, $ports) = modellookup($device[name]);
    if ( $model ) {
      echo "# $cname\n";
      echo "# Ethernet address   interface   number of ports (1,2,4,8,16,32)    link timeout (sec)\n";
      echo $device[mac]."       eth0        $ports                          600\n";
      echo "#$device[ip]        1                         10\n";
      echo "# Port number (1-8)   RsMode (232, 422, 485, or Off)\n";
      for ($p = 1; $p <= $ports; $p++) {
        echo "$p                     232\n";
      }
      echo "\n";
      $c++;
    }
  }
  echo "\n";
  echo "# device count = $c";
  echo "</pre>\n";

}

function reportdminstaller($selection) {
  $alldevices = scandevices();
  $c = 0;
  foreach ($alldevices as $device) {
    foreach ($selection as $key => $value) {
      if ($device[mac] == $value) {
        $devices[$c][mac] = $device[mac];
        $devices[$c][name] = $device[name];
        $devices[$c][status] = $device[status];
        $devices[$c][owned] = $device[owned];
        $devices[$c][ip] = $device[ip];
        $devices[$c][sortip] = $device[sortip];
        $devices[$c][sortmac] = $device[sortmac];
        $devices[$c][mask] = $device[mask];
        $devices[$c][gateway] = $device[gateway];
        $c++;
      }
    }
  }

  echo "<pre>\n";
  echo "; DeviceMasterInstaller.ini\n";
  echo "; For use with Windows based DeviceMaster Installer script\n";
  echo "; Autogenerated by Web PortVision\n";
  echo "; MODIFY AS NEEDED\n";
  echo "\n";
  echo "; Model List\n";
  echo "; 1) DeviceMaster AIR\n";
  echo "; 2) DeviceMaster Pro 16\n";
  echo "; 3) DeviceMaster Pro 8\n";
  echo "; 4) DeviceMaster RTS 1\n";
  echo "; 5) DeviceMaster RTS 16\n";
  echo "; 6) DeviceMaster RTS 32\n";
  echo "; 7) DeviceMaster RTS 4\n";
  echo "; 8) DeviceMaster RTS 8\n";
  echo "; 9) DeviceMaster SerialHub 16\n";
  echo "; 10) DeviceMaster SerialHub 8\n";
  echo "; 11) RocketPort SerialHub IA 2\n";
  echo "; 12) RocketPort SerialHub SI 2\n";
  echo "; 13) RocketPort SerialHub SI 4\n";
  echo "; 14) RocketPort SerialHub SI 8\n";
  echo "\n";
  echo "; Here is a list of all assignable options.\n";
  echo "; Model = #                ; Device model from the above list\n";
  echo "; Mode = ip|mac            ; Use the driver in IP or MAC mode\n";
  echo ";                          ;  Default: mac\n";
  echo "; Mac = # # # # # #        ; The hex MAC address of the device in this format\n";
  echo ";                          ;  Default: 0 0 0 0 0 0\n";
  echo "; IP = #.#.#.#             ; The IP address of the device, if modified from default.\n";
  echo ";                          ;  Default: 0.0.0.0\n";
  echo "; Port#Mode = 232|422|485  ; The RS mode the port should be.\n";
  echo ";                          ;  Default: 232\n";
  echo "; Port#COM = COM#          ; The Windows COM number that should be assigned to the port\n";
  echo ";                          ;  (Note that any COM numbering conflictions are not be detected or reported)\n";
  echo ";                          ;  Default: determined/assigned by Windows\n";
  echo "\n";
  $c=0;
  foreach ($devices as $device) {
    list ($model, $cname, $ports) = modellookup($device[name]);
    if ( $model ) {
      $halfmac = explode (":", $device[mac]);
      $mac = str_replace(':', " ", $device[mac]);
      echo "[$cname-$halfmac[3]:$halfmac[4]:$halfmac[5]]\n";
      echo "mac = $mac\n";
      echo "mode = mac\n";
      echo "model = $model\n";
      echo "\n";
      $c++;
    }
  }
  echo "\n";
  echo "; device count = $c";
  echo "</pre>\n";

}

function modellookup($name) {
  $models["DeviceMaster AIR 1"] = 1;
  $models["DeviceMaster Pro 16"] = 2;
  $models["DeviceMaster Pro 8"] = 3;
  $models["DeviceMaster RTS 1"] = 4;
  $models["DeviceMaster RTS 16"] = 5;
  $models["DeviceMaster RTS 32"] = 6;
  $models["DeviceMaster RTS 4"] = 7;
  $models["DeviceMaster RTS 8"] = 8;
  $models["DeviceMaster SerialHub 16"] = 9;
  $models["DeviceMaster SerialHub 8"] = 10;
  $models["RocketPort SerialHub IA 2"] = 11;
  $models["RocketPort SerialHub SI 2"] = 12;
  $models["RocketPort SerialHub SI 4"] = 13;
  $models["RocketPort SerialHub SI 8"] = 14;

  $cname["DeviceMaster AIR 1"] = "DMAIR1";
  $cname["DeviceMaster Pro 16"] = "DMPRO16";
  $cname["DeviceMaster Pro 8"] = "DMPRO8";
  $cname["DeviceMaster RTS 1"] = "DMRTS1";
  $cname["DeviceMaster RTS 16"] = "DMRTS16";
  $cname["DeviceMaster RTS 32"] = "DMRTS32";
  $cname["DeviceMaster RTS 4"] = "DMRTS4";
  $cname["DeviceMaster RTS 8"] = "DMRTS8";
  $cname["DeviceMaster SerialHub 16"] = "DMSH16";
  $cname["DeviceMaster SerialHub 8"] = "DMSH8";
  $cname["RocketPort SerialHub IA 2"] = "RPSHIA2";
  $cname["RocketPort SerialHub SI 2"] = "RPSHSI2";
  $cname["RocketPort SerialHub SI 4"] = "RPSHSI4";
  $cname["RocketPort SerialHub SI 8"] = "RPSHSI8";

  $ports["DeviceMaster AIR 1"] = 1;
  $ports["DeviceMaster Pro 16"] = 16;
  $ports["DeviceMaster Pro 8"] = 8;
  $ports["DeviceMaster RTS 1"] = 1;
  $ports["DeviceMaster RTS 16"] = 16;
  $ports["DeviceMaster RTS 32"] = 32;
  $ports["DeviceMaster RTS 4"] = 4;
  $ports["DeviceMaster RTS 8"] = 8;
  $ports["DeviceMaster SerialHub 16"] = 16;
  $ports["DeviceMaster SerialHub 8"] = 8;
  $ports["RocketPort SerialHub IA 2"] = 2;
  $ports["RocketPort SerialHub SI 2"] = 2;
  $ports["RocketPort SerialHub SI 4"] = 4;
  $ports["RocketPort SerialHub SI 8"] = 8;

  $namechunk = explode (" [", $name);
  //echo "DEBUG: name: $name | namechunk: $namechunk[0] | model: ".$models["$namechunk[0]"]."<br>\n";
  return array ($models["$namechunk[0]"], $cname["$namechunk[0]"], $ports["$namechunk[0]"]);
}

function writecachedata($alldevices) {
  global $cachefile;

  // write the device data to a file to use as cached data
  if (! $usecache) {
    $cachehandle = fopen($cachefile, "w");
    fputs($cachehandle, time()."\n");
    foreach ($alldevices as $device) {
      foreach ($device as $key => $value) {
        $key = trim($key);
        $value = trim($value);
        fputs($cachehandle, "$key::$value,,");
      }
      fputs($cachehandle, "\n");
    }
    fclose($cachehandle);
  }
}

function opensocket($ip) {
  $fp = @fsockopen("tcp://$ip", 4607, $errno, $errstr, 5);
  if ($fp) {
    stream_set_blocking ( $fp, FALSE );
    stream_set_timeout($fp, 2);
  }
  return $fp;
}

function closesocket(&$fp) {
  fclose($fp);
  unset($fp);
}

function debugsocket($ip) {
  $sleeptime = 1000000; // in microseconds
  $timeout = 12; // in seconds

  $self = $_SERVER['SCRIPT_NAME'];
  ?>
  <html>
  <head>
    <title>Web PortVision: Debuging Device at <?=$ip?></title>
    <script language="JavaScript">
function scrollit() {
                parent.scrollBy(1,100)
}    </script>
  </head>
  <body>
  <?php
  $fp = opensocket($ip);
  $time = 0;
  ob_implicit_flush(1);
  while (1) {
    if (!$fp) { echo "<font color=red>Connection not open. Attempting to connect to device at: $ip</font><br>\n"; $fp = opensocket($ip); }
    elseif ($status['timed_out']) { echo "<font color=red>Connection lost to device at: $ip. Attempting to reconnect...</font><br>\n"; closesocket($fp); $fp = opensocket($ip); }
//    if (!$fp || !$status['timed_out']) { closesocket($fp); $fp = opensocket($ip); }
    else {
      $in = fgets($fp, 128);
//      $in = socket_read($fp, 128);
      $in = preg_replace("/\n\s*\n/", "\n", $in);
      $in = preg_replace("/\n/", "<br><script language=\"JavaScript\">scrollit()</script>", $in);
      if (! $in) {
        $time += ($sleeptime / 1000000);
        // sleep only if we dont get any data last grab
        usleep($sleeptime);
        //echo "time: $time\n";
      }
      else { $time = 0; }
      // if i timeout or the socket does, reopen it.
//      if ($time >= $timeout || feof($fp)) {
      if ($time >= $timeout) {
        $time = 0;
        closesocket($fp);
        echo "<font color=red>Timeout occured. Closing and reopening connection...</font><br>\n";
        $fp = opensocket($ip);
      }
      echo $in;
      //$status = stream_get_meta_data($fp);
      $status = @socket_get_status($fp);
    }
  }
  ob_implicit_flush(0);
  ?>
  </body>
  </html>
  <?php

  /*if (!$fp) {
     echo "$errstr ($errno)<br />\n";
  } else {
     $out = "GET / HTTP/1.1\r\n";
     $out .= "Host: www.example.com\r\n";
     $out .= "Connection: Close\r\n\r\n";

     fwrite($fp, $out);
     while (!feof($fp)) {
         echo fgets($fp, 128);
     }
     fclose($fp);
  }
  */
  closesocket($fp);
}


function onedevice($origmac, $interface) {
  global $nslinkadmin;
  $self = $_SERVER['SCRIPT_NAME'];

  $device = shell_exec("$nslinkadmin -d $interface -e $origmac -n -L");
  $device = str_replace("(", "", $device);
  $device = str_replace(")", "", $device);
  $device = str_replace('"', "", $device);
  list ($mac, $name, $status, $owned) = explode (",", $device);
  // next get the ip info from the devices
  if ($mac) {
    $ipinforaw = shell_exec("$nslinkadmin -d $interface -q -e $mac");
    $ipinforaw = str_replace('"', "", $ipinforaw);
    list ($ip, $mask, $gateway) = explode (",", $ipinforaw);
  }
  
  $status = str_replace("running", "<font color=green>YES</font>", $status);
  $status = str_replace("idle", "<font color=red>NO</font>", $status);
  ?>
  <html>
  <head>
    <title>Web PortVision: Device <?=$mac?></title>
  </head>
  <body>
  <table width="100%" border="0" cellpadding="1" cellspacing="1">
    <tbody>
      <tr>
        <td>
          <form method="GET" action="<?php echo $self; ?>"> 
            <input type="hidden" name="mac" value="<?=$origmac?>">
            <center><input type="submit" value="Refresh Page"></center>
          </form>
        </td>
      </tr>
    </tbody>
  </table>
  <br>
  <table width="100%" border="0" cellpadding="1" cellspacing="1">
    <tbody>
      <tr>
        <td bgcolor=#D3DCE3>Name</td>
        <td bgcolor=#D3DCE3>IP Info</td>
        <td bgcolor=#D3DCE3>Mac Address</td>
        <td bgcolor=#D3DCE3>Ready?</td>
        <td bgcolor=#D3DCE3>Actions</td>
      </tr>
  <?php
  if ($mac) {
  ?>
      <form method="GET" action="<?=$self?>">
      <input type="hidden" name="mac" value="<?=$mac?>">
      <input type="hidden" name="reset" value="<?=$mac?>">
      <tr>
       <td BGCOLOR=CCCCCC><?=$name?></td>
       <td BGCOLOR=CCCCCC><pre>ip:      <a href="http://<?=$ip?>"><?=$ip?></a><br>netmask: <?=$mask?><br>gateway: <?=$gateway?></pre></td>
       <td BGCOLOR=CCCCCC><pre><?=$mac?></pre></td>
       <td BGCOLOR=CCCCCC><?=$status?></td>
       <td BGCOLOR=CCCCCC><input type="submit" value="Reset"></td>
      </tr>
      </form>
    </tbody>
  </table>
  <?php
  }
  else {
    echo "</tbody></table>\n";
    echo "<font color=red>No devices detected with MAC address '$origmac'. Perhaps its still rebooting? Try refreshing.</font><br>\n";
  }
  ?>
  <br>
  <br>
  <table width="100%" border="0" cellpadding="0" cellspacing="0">
    <tbody>
      <tr>
        <td width=50%> 
          <table width="100%" border="0" cellpadding="1" cellspacing="1">
            <tbody>
              <tr>
                <td>
                  <form method="GET" action="<?php echo $self; ?>"> 
                  <input type="hidden" name="mac" value="<?=$mac?>">
                  <tr><td>IP Address</td><td><input type=text name="ip" value="<?php echo $ip; ?>" size=17></td></tr>
                  <tr><td>Network Mask</td><td><input type=text name="mask" value="<?php echo $mask; ?>" size=17></td></tr>
                  <tr><td>Gateway IP</td><td><input type=text name="gateway" value="<?php echo $gateway; ?>" size=17></td></tr>
                  <tr><td colspan=2><center><input type="submit" name="setipinfo" value="Set New IP Information"></center></td></tr>
                  </form>
                </td>
              </tr>
            </tbody>
          </table>
        </td>
        <td width=50%>
          <table width="100%" border="0" cellpadding="1" cellspacing="1">
            <tbody>
              <tr>
                <td>
                  <form enctype="multipart/form-data" action="<?php echo $self; ?>" method="POST">
                  <input type="hidden" name="mac" value="<?=$mac?>">
                  <!-- MAX_FILE_SIZE must precede the file input field -->
                  <input type="hidden" name="MAX_FILE_SIZE" value="3000000" />
                  <!-- Name of input element determines name in $_FILES array -->
                  Send this file: <input name="userfile" type="file" />
                  <center><input type="submit" name="firmwareupload" value="Upload Firmware" /></center>
                  </form>
                </td>
              </tr>
            </tbody>
        </td>
      </tr> 
    </tbody>
  </table>
  <?php
}


function scandevices() {
  global $nslinkadmin;
  global $interface;
  global $cachefile;
  $alldevices;

  // read the cached data if the time is within threshold
  if ($debug) { echo "DEBUG: cachefile is '$cachefile' <br>\n"; }
  if ((is_file($cachefile)) && (filesize($cachefile) > 0)) {
     if ($debug) { echo "DEBUG: cachefile '$cachefile' exists and is size: ".filesize($cachefile)."<br>\n"; }
    $filesize = filesize($cachefile);
    $cachehandle = fopen($cachefile, "r+");
    $time = fgets($cachehandle);
    $contents = fread($cachehandle, $filesize);
  
    if (time() <= ($time+$cachedtime)) {
      $cacheddevices = explode ("\n", $contents);
      for ($c = 0; $c <= count($cacheddevices); $c++) {
        $cacheddevice = explode (",,", $cacheddevices[$c]);
        foreach ($cacheddevice as $pair) {
          list ($key, $value) = explode ("::", $pair);
          if (($key) && ($value)) {
            $alldevices[$c][$key] = $value;
            if ($debug) {echo "DEBUG: \$devices[$c][$key] = $value<br>\n"; }
          }
        }
      }
      $usecache = 1;
    }
    fclose($cachehandle);
  }
  if (! $usecache) {
    $devicelistraw = shell_exec("$nslinkadmin -d $interface -n -L");
    if ($debug) { echo "DEBUG: raw data: <pre>$devicelistraw</pre>"; }
  
    $devicelistrawarray = explode ("),(", $devicelistraw);
  
    if ($debug) {
      foreach ($devicelistrawarray as $entry) {
        echo $entry."<BR>";
      }
    }
  
    $ac = 0;
    foreach ($devicelistrawarray as $deviceentry) {
      // typical entry
      // "00:c0:4e:15:01:a3","DeviceMaster [5002280] 1-port v3.15","running","owned"
      $deviceentry = str_replace("(", "", $deviceentry);
      $deviceentry = str_replace(")", "", $deviceentry);
      $deviceentry = str_replace('"', "", $deviceentry);
      list ($mac, $name, $status, $owned) = explode (",", $deviceentry);
      // next get the ip info from the devices
      $ipinforaw = shell_exec("$nslinkadmin -d $interface -q -e $mac");
      $ipinforaw = str_replace('"', "", $ipinforaw);
      list ($ip, $mask, $gateway) = explode (",", $ipinforaw);
    
      $status = str_replace("running", "YES", $status);
      $status = str_replace("idle", "NO", $status);
      list ($oct1, $oct2, $oct3, $oct4) = explode(".", $ip);
      $sortip = str_pad($oct1, 3, "0", STR_PAD_LEFT).str_pad($oct2, 3, "0", STR_PAD_LEFT).str_pad($oct3, 3, "0", STR_PAD_LEFT).str_pad($oct4, 3, "0", STR_PAD_LEFT);
      $sortmac = str_replace(":", "", $mac);
  
      $alldevices[$ac][mac] = $mac;
      $alldevices[$ac][name] = $name;
      $alldevices[$ac][status] = $status;
      $alldevices[$ac][owned] = $owned;
      $alldevices[$ac][ip] = $ip;
      $alldevices[$ac][sortip] = $sortip;
      $alldevices[$ac][sortmac] = $sortmac;
      $alldevices[$ac][mask] = $mask;
      $alldevices[$ac][gateway] = $gateway;
      $ac++;
    }
  }
  return $alldevices;
}

// currently this function not being used and isnt working yet at all
function getinterfaces() {
  global $nslinkadmin;

  $interfacesraw = shell_exec('/sbin/ifconfig');
  $pattern = "/(\w+) (\d+), (\d+)/i";
  $replacement = "\${1}1,\$3";
  echo preg_replace($pattern, $replacement, $string);

}

function resetdevice($mac, $interface) {
  global $nslinkadmin;

  if ($debug) { echo "DEBUG: reseting device $mac on interface $interface<br>\n"; }
  $result = shell_exec("$nslinkadmin -d $interface -e $mac -r");
}

function guiflashdevice($mac, $interface) {
  $seconds = 20;

  echo "<html><head><META HTTP-EQUIV=\"REFRESH\" content=\"$seconds;URL='$self?mac=$mac'\"></head><body>";
  echo "<font color=red><big>Flashing device now... Auto refreshing this page after $seconds seconds</big></font><br><br>\n";
  ?>
  <form method="GET" action="<?=$self?>">
  <input type="hidden" name="mac" value="<?=$mac?>">
  <center><input type="submit" value="Refresh Page Now"></center>
  </form>
  <?php
  echo "</body></html>\n";
  flashdevice($mac, $interface);
}

function flashdevice($mac, $interface) {
  global $nslinkadmin;

  if ($debug) { print_r($_FILES)."<br><br>\n"; }
  $result = shell_exec("$nslinkadmin -d $interface -e $mac -r");
  if ($debug) { echo "DEBUG: reseting device '$mac' on interface '$interface': $result<br>\n"; }
  // reboot the device, then do a silly 5 second wait, then try to upload firmware... find a better way if possible
  sleep(5);
  $result = shell_exec("$nslinkadmin -d $interface -e $mac -f ".$_FILES[userfile][tmp_name]." -l");
  if ($debug) { echo "DEBUG: flashing device '$mac' with '".$_FILES[userfile][tmp_name]."': $result<br>\n"; }
}

function setipinfo($mac, $interface, $ip, $mask, $gateway) {
  global $nslinkadmin;

  if ($debug) { echo "DEBUG: setting ip info on device $mac on interface $interface with $ip<br>\n"; }
  $result = shell_exec("$nslinkadmin -d $interface -e $mac -a $ip -m $mask -g $gateway");
}
?>